diff --git a/game/client/src/main/java/net/minecraft/client/gui/Gui.java b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
index 355a19db6..b3abca07c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Gui.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
@@ -216,203 +217,183 @@ public class Gui
         GL11.glEnable(GL_TEXTURE_2D);
     }
 
-    public void drawTextCentered(Font fr, Text text, int x, int y, int argb)
-    {
-        fr.drawTextWithShadow(text, x - fr.getTextWidth(text) / 2, y, argb);
-    }
-
-    public void drawTextCenteredNoShadow(Font fr, Text text, int x, int y, int argb)
-    {
-        fr.drawText(text, x - fr.getTextWidth(text) / 2, y, argb);
+    public void drawStringCenteredShadow(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int argb) {
+        FontHelper.renderCentered(Tessellator.instance, chars, x, y).setZ(this.zLevel).setShadow().setColor(argb).call(fontRenderer);
     }
-
-    public void drawText(Font fr, Text text, int x, int y, int argb)
-    {
-        fr.drawTextWithShadow(text, x, y, argb);
-    }
-
-    public void drawTextNoShadow(Font fr, Text text, int x, int y, int argb)
-    {
-        fr.drawText(text, x, y, argb);
+    
+    public void drawStringCenteredNoShadow(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int argb) {
+        FontHelper.renderCentered(Tessellator.instance, chars, x, y).setZ(this.zLevel).setColor(argb).call(fontRenderer);
     }
 
-    public void drawStringCentered(Font fr, String string, int x, int y, int argb)
-    {
-        fr.drawStringWithShadow(string, x - fr.getStringWidth(string) / 2, y, argb);
+    public void drawStringShadow(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int argb) {
+        FontHelper.render(Tessellator.instance, chars, x, y).setZ(this.zLevel).setShadow().setColor(argb).call(fontRenderer);
     }
     
-    public void drawStringCenteredNoShadow(Font fr, String string, int x, int y, int argb)
-    {
-        fr.drawString(string, x - fr.getStringWidth(string) / 2, y, argb);
+    public void drawStringNoShadow(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int argb) {
+        FontHelper.render(Tessellator.instance, chars, x, y).setZ(this.zLevel).setColor(argb).call(fontRenderer);
     }
 
-    public void drawString(Font fr, String string, int x, int y, int argb)
-    {
-        fr.drawStringWithShadow(string, x, y, argb);
-    }
-    
-    public void drawStringNoShadow(Font fr, String string, int x, int y, int argb)
-    {
-    	fr.drawString(string, x, y, argb);
+    public void drawStringConstrained(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int maxWidth, final int argb) {
+        FontHelper.renderWidthConstrained(Tessellator.instance, chars, x, y, maxWidth).setZ(this.zLevel).setColor(argb).call(fontRenderer);
     }
 
-    public void drawTexturedModalRect(int x, int y, int u, int v, int width, int height)
+    public void drawTexturedModalRect(final int x, final int y, final int u, final int v, final int width, final int height)
     {
-        float uScale = 0.00390625F;
-        float vScale = 0.00390625F;
-        Tessellator tessellator = Tessellator.instance;
+        final float uScale = 0.00390625F;
+        final float vScale = 0.00390625F;
+        final Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x + 0, y + height, zLevel, (u + 0) * uScale, (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width, y + height, zLevel, (u + width) * uScale, (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width, y + 0, zLevel, (u + width) * uScale, (v + 0) * vScale);
-        tessellator.addVertexWithUV(x + 0, y + 0, zLevel, (u + 0) * uScale, (v + 0) * vScale);
+        tessellator.addVertexWithUV(x, y + height, this.zLevel, (u) * uScale, (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width, y + height, this.zLevel, (u + width) * uScale, (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width, y, this.zLevel, (u + width) * uScale, (v) * vScale);
+        tessellator.addVertexWithUV(x, y, this.zLevel, (u) * uScale, (v) * vScale);
         tessellator.draw();
     }
-    public void drawTexturedModalRect(int x, int y, int u, int v, int width, int height, double uScale, double vScale)
+    public void drawTexturedModalRect(final int x, final int y, final int u, final int v, final int width, final int height, final double uScale, final double vScale)
     {
         final double off = 0.05d;
-        Tessellator tessellator = Tessellator.instance;
+        final Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x - off,        y + height + off,   zLevel, (u + 0) * uScale,        (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y + height + off,   zLevel, (u + width) * uScale,    (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y - off,            zLevel, (u + width) * uScale,    (v + 0) * vScale);
-        tessellator.addVertexWithUV(x - off,        y - off,            zLevel, (u + 0) * uScale,        (v + 0) * vScale);
+        tessellator.addVertexWithUV(x - off,        y + height + off, this.zLevel, (u) * uScale,        (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y + height + off, this.zLevel, (u + width) * uScale,    (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y - off, this.zLevel, (u + width) * uScale,    (v) * vScale);
+        tessellator.addVertexWithUV(x - off,        y - off, this.zLevel, (u) * uScale,        (v) * vScale);
         tessellator.draw();
     }
-    public void drawTexturedModalRectDouble(double x, double y, double u, double v, double width, double height, double uScale, double vScale)
+    public void drawTexturedModalRectDouble(final double x, final double y, final double u, final double v, final double width, final double height, final double uScale, final double vScale)
     {
         final double off = 0.05d;
-        Tessellator tessellator = Tessellator.instance;
+        final Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x - off,        y + height + off,   zLevel, (u + 0) * uScale,        (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y + height + off,   zLevel, (u + width) * uScale,    (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y - off,            zLevel, (u + width) * uScale,    (v + 0) * vScale);
-        tessellator.addVertexWithUV(x - off,        y - off,            zLevel, (u + 0) * uScale,        (v + 0) * vScale);
+        tessellator.addVertexWithUV(x - off,        y + height + off, this.zLevel, (u + 0) * uScale,        (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y + height + off, this.zLevel, (u + width) * uScale,    (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y - off, this.zLevel, (u + width) * uScale,    (v + 0) * vScale);
+        tessellator.addVertexWithUV(x - off,        y - off, this.zLevel, (u + 0) * uScale,        (v + 0) * vScale);
         tessellator.draw();
     }
 
-    public void drawTexturedModalRect(int x, int y, int u, int v, int width, int height, double uScale, double vScale, double off)
+    public void drawTexturedModalRect(final int x, final int y, final int u, final int v, final int width, final int height, final double uScale, final double vScale, final double off)
     {
-        Tessellator tessellator = Tessellator.instance;
+        final Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x - off,        y + height + off,   zLevel, (u + 0) * uScale,        (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y + height + off,   zLevel, (u + width) * uScale,    (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y - off,            zLevel, (u + width) * uScale,    (v + 0) * vScale);
-        tessellator.addVertexWithUV(x - off,        y - off,            zLevel, (u + 0) * uScale,        (v + 0) * vScale);
+        tessellator.addVertexWithUV(x - off,        y + height + off, this.zLevel, (u) * uScale,        (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y + height + off, this.zLevel, (u + width) * uScale,    (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y - off, this.zLevel, (u + width) * uScale,    (v) * vScale);
+        tessellator.addVertexWithUV(x - off,        y - off, this.zLevel, (u) * uScale,        (v) * vScale);
         tessellator.draw();
     }
 
-    public void drawTexturedModalRectDouble(double x, double y, double u, double v, double width, double height, double uScale, double vScale, double off)
+    public void drawTexturedModalRectDouble(final double x, final double y, final double u, final double v, final double width, final double height, final double uScale, final double vScale, final double off)
     {
         final double foon = /*(0.25d * uScale)*/0;
         final double goon = /*(0.25d * vScale)*/0;
-        Tessellator tessellator = Tessellator.instance;
+        final Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x - off,        y + height + off,   zLevel, (u + 0.5) * uScale,       (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y + height + off,   zLevel, (u + width - 0.5) * uScale,   (v + height) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y - off,            zLevel, (u + width - 0.5) * uScale,    v * vScale);
-        tessellator.addVertexWithUV(x - off,        y - off,            zLevel, (u + 0.5) * uScale,        v * vScale);
+        tessellator.addVertexWithUV(x - off,        y + height + off, this.zLevel, (u + 0.5) * uScale,       (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y + height + off, this.zLevel, (u + width - 0.5) * uScale,   (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y - off, this.zLevel, (u + width - 0.5) * uScale,    v * vScale);
+        tessellator.addVertexWithUV(x - off,        y - off, this.zLevel, (u + 0.5) * uScale,        v * vScale);
         tessellator.draw();
     }
 
 
-    public void drawTexturedModalRectDouble(double x, double y, double u, double v, double width, double height, double uWidth, double vHeight, double uScale, double vScale)
+    public void drawTexturedModalRectDouble(final double x, final double y, final double u, final double v, final double width, final double height, final double uWidth, final double vHeight, final double uScale, final double vScale)
     {
         final double foon = (0.5f * uScale);
         final double goon = 0.0625f * (16.0f / uWidth);
         final double off = 0.05d;
-        Tessellator tessellator = Tessellator.instance;
+        final Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x - off,        y + height + off,   zLevel, (u + foon) * uScale,             (v + vHeight - foon) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y + height + off,   zLevel, (u + uWidth - foon) * uScale,    (v + vHeight - foon) * vScale);
-        tessellator.addVertexWithUV(x + width + off,y - off,            zLevel, (u + uWidth - foon) * uScale,    (v + foon) * vScale);
-        tessellator.addVertexWithUV(x - off,        y - off,            zLevel, (u + foon) * uScale,             (v + foon) * vScale);
+        tessellator.addVertexWithUV(x - off,        y + height + off, this.zLevel, (u + foon) * uScale,             (v + vHeight - foon) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y + height + off, this.zLevel, (u + uWidth - foon) * uScale,    (v + vHeight - foon) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y - off, this.zLevel, (u + uWidth - foon) * uScale,    (v + foon) * vScale);
+        tessellator.addVertexWithUV(x - off,        y - off, this.zLevel, (u + foon) * uScale,             (v + foon) * vScale);
         tessellator.draw();
     }
 
-    public void drawTexturedModalRect(double x, double y, int u, int v, int width, int height, int uvWidth, int uvHeight)
+    public void drawTexturedModalRect(final double x, final double y, final int u, final int v, final int width, final int height, final int uvWidth, final int uvHeight)
     {
-        float uScale = 0.00390625F;
-        float vScale = 0.00390625F;
-        Tessellator tessellator = Tessellator.instance;
+        final float uScale = 0.00390625F;
+        final float vScale = 0.00390625F;
+        final Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x + 0, y + height, zLevel, (u + 0) * uScale, (v + uvHeight) * vScale);
-        tessellator.addVertexWithUV(x + width, y + height, zLevel, (u + uvWidth) * uScale, (v + uvHeight) * vScale);
-        tessellator.addVertexWithUV(x + width, y + 0, zLevel, (u + uvWidth) * uScale, (v + 0) * vScale);
-        tessellator.addVertexWithUV(x + 0, y + 0, zLevel, (u + 0) * uScale, (v + 0) * vScale);
+        tessellator.addVertexWithUV(x + 0, y + height, this.zLevel, (u) * uScale, (v + uvHeight) * vScale);
+        tessellator.addVertexWithUV(x + width, y + height, this.zLevel, (u + uvWidth) * uScale, (v + uvHeight) * vScale);
+        tessellator.addVertexWithUV(x + width, y + 0, this.zLevel, (u + uvWidth) * uScale, (v) * vScale);
+        tessellator.addVertexWithUV(x + 0, y + 0, this.zLevel, (u) * uScale, (v) * vScale);
         tessellator.draw();
     }
     
-    public void drawTexturedModalRect(int x, int y, int u, int v, int width, int height, int uvWidth, float scale)
+    public void drawTexturedModalRect(final int x, final int y, final int u, final int v, final int width, final int height, final int uvWidth, final float scale)
     {
-        float uScale = scale;
-        float vScale = scale;
-        Tessellator tessellator = Tessellator.instance;
+        final float uScale = scale;
+        final float vScale = scale;
+        final Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x + 0, y + height, zLevel, (u + 0) * uScale, (v + uvWidth) * vScale);
-        tessellator.addVertexWithUV(x + width, y + height, zLevel, (u + uvWidth) * uScale, (v + uvWidth) * vScale);
-        tessellator.addVertexWithUV(x + width, y + 0, zLevel, (u + uvWidth) * uScale, (v + 0) * vScale);
-        tessellator.addVertexWithUV(x + 0, y + 0, zLevel, (u + 0) * uScale, (v + 0) * vScale);
+        tessellator.addVertexWithUV(x, y + height, this.zLevel, (u) * uScale, (v + uvWidth) * vScale);
+        tessellator.addVertexWithUV(x + width, y + height, this.zLevel, (u + uvWidth) * uScale, (v + uvWidth) * vScale);
+        tessellator.addVertexWithUV(x + width, y, this.zLevel, (u + uvWidth) * uScale, (v) * vScale);
+        tessellator.addVertexWithUV(x, y, this.zLevel, (u) * uScale, (v) * vScale);
         tessellator.draw();
     }
-    public void drawTexturedIcon(int x, int y, int width, int height, IconCoordinate coordinate)
+    public void drawTexturedIcon(final int x, final int y, final int width, final int height, final IconCoordinate coordinate)
     {
         coordinate.parentAtlas.bind();
-        Tessellator tessellator = Tessellator.instance;
+        final Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x + 0,      y + height, zLevel, coordinate.getIconUMin(), coordinate.getIconVMax());
-        tessellator.addVertexWithUV(x + width,  y + height, zLevel, coordinate.getIconUMax(), coordinate.getIconVMax());
-        tessellator.addVertexWithUV(x + width,  y + 0,      zLevel, coordinate.getIconUMax(), coordinate.getIconVMin());
-        tessellator.addVertexWithUV(x + 0,      y + 0,      zLevel, coordinate.getIconUMin(), coordinate.getIconVMin());
+        tessellator.addVertexWithUV(x,      y + height, this.zLevel, coordinate.getIconUMin(), coordinate.getIconVMax());
+        tessellator.addVertexWithUV(x + width,  y + height, this.zLevel, coordinate.getIconUMax(), coordinate.getIconVMax());
+        tessellator.addVertexWithUV(x + width, y, this.zLevel, coordinate.getIconUMax(), coordinate.getIconVMin());
+        tessellator.addVertexWithUV(x, y, this.zLevel, coordinate.getIconUMin(), coordinate.getIconVMin());
         tessellator.draw();
     }
 
-    public void drawGuiTexture(TextureManager re, int x, int y, int width, int height, String texture) {
-        Texture tex = re.loadTexture(texture);
+    public void drawGuiTexture(final TextureManager re, final int x, final int y, final int width, final int height, final String texture) {
+        final Texture tex = re.loadTexture(texture);
         tex.bind();
 
-        Tessellator t = Tessellator.instance;
+        final Tessellator t = Tessellator.instance;
         if (tex.hasMeta("gui")) {
-            GuiTextureProperties properties = Objects.requireNonNull(tex.getMeta("gui", GuiTextureProperties.class));
+            final GuiTextureProperties properties = Objects.requireNonNull(tex.getMeta("gui", GuiTextureProperties.class));
             switch (properties.type) {
                 case GuiTextureProperties.TYPE_STRETCH: {
                     t.startDrawingQuads();
-                    t.addVertexWithUV(x, y + height, zLevel, 0, 1);
-                    t.addVertexWithUV(x + width, y + height, zLevel, 1, 1);
-                    t.addVertexWithUV(x + width, y, zLevel, 1, 0);
-                    t.addVertexWithUV(x, y, zLevel, 0, 0);
+                    t.addVertexWithUV(x, y + height, this.zLevel, 0, 1);
+                    t.addVertexWithUV(x + width, y + height, this.zLevel, 1, 1);
+                    t.addVertexWithUV(x + width, y, this.zLevel, 1, 0);
+                    t.addVertexWithUV(x, y, this.zLevel, 0, 0);
                     t.draw();
                     break;
                 }
                 case GuiTextureProperties.TYPE_TILE: {
-                    double uScale = 1d/ properties.width;
-                    double vScale = 1d/ properties.height;
+                    final double uScale = 1d/ properties.width;
+                    final double vScale = 1d/ properties.height;
                     t.startDrawingQuads();
-                    t.addVertexWithUV(x        , y + height, zLevel, 0,              height * vScale);
-                    t.addVertexWithUV(x + width, y + height, zLevel, width * uScale, height * vScale);
-                    t.addVertexWithUV(x + width, y         , zLevel, width * uScale, 0);
-                    t.addVertexWithUV(x        , y         , zLevel, 0,              0);
+                    t.addVertexWithUV(x        , y + height, this.zLevel, 0,              height * vScale);
+                    t.addVertexWithUV(x + width, y + height, this.zLevel, width * uScale, height * vScale);
+                    t.addVertexWithUV(x + width, y         , this.zLevel, width * uScale, 0);
+                    t.addVertexWithUV(x        , y         , this.zLevel, 0,              0);
                     t.draw();
                     break;
                 }
                 case GuiTextureProperties.TYPE_NINE_SLICE: {
-                    double uScale = 1d / properties.width;
-                    double vScale = 1d / properties.height;
+                    final double uScale = 1d / properties.width;
+                    final double vScale = 1d / properties.height;
 
-                    int innerWidth = properties.width - (properties.border.left + properties.border.right);
-                    int innerHeight = properties.height - (properties.border.top + properties.border.bottom);
-                    int innerLeft = properties.border.left;
-                    int innerTop = properties.border.top;
-                    int innerRight = properties.width - properties.border.right;
-                    int innerBottom = properties.height - properties.border.bottom;
+                    final int innerWidth = properties.width - (properties.border.left + properties.border.right);
+                    final int innerHeight = properties.height - (properties.border.top + properties.border.bottom);
+                    final int innerLeft = properties.border.left;
+                    final int innerTop = properties.border.top;
+                    final int innerRight = properties.width - properties.border.right;
+                    final int innerBottom = properties.height - properties.border.bottom;
 
-                    int leftHeight = height - (properties.border.top + properties.border.bottom);
-                    int repeatsY = leftHeight / innerHeight;
-                    int remainderY = leftHeight % innerHeight;
+                    final int leftHeight = height - (properties.border.top + properties.border.bottom);
+                    final int repeatsY = leftHeight / innerHeight;
+                    final int remainderY = leftHeight % innerHeight;
 
-                    int topWidth = width - (properties.border.left + properties.border.right);
-                    int repeatsX = topWidth / innerWidth;
-                    int remainderX = topWidth % innerWidth;
+                    final int topWidth = width - (properties.border.left + properties.border.right);
+                    final int repeatsX = topWidth / innerWidth;
+                    final int remainderX = topWidth % innerWidth;
 
                     { // Inner
                         if (properties.stretchInner) { // Stretch Inner // TODO implement
@@ -535,41 +516,41 @@ public class Gui
             }
         } else {
             t.startDrawingQuads();
-            t.addVertexWithUV(x        , y + height, zLevel, 0, 1);
-            t.addVertexWithUV(x + width, y + height, zLevel, 1, 1);
-            t.addVertexWithUV(x + width, y         , zLevel, 1, 0);
-            t.addVertexWithUV(x        , y         , zLevel, 0, 0);
+            t.addVertexWithUV(x        , y + height, this.zLevel, 0, 1);
+            t.addVertexWithUV(x + width, y + height, this.zLevel, 1, 1);
+            t.addVertexWithUV(x + width, y         , this.zLevel, 1, 0);
+            t.addVertexWithUV(x        , y         , this.zLevel, 0, 0);
             t.draw();
         }
     }
 
-    public void drawGuiIcon(int x, int y, int width, int height, IconCoordinate coordinate) {
+    public void drawGuiIcon(final int x, final int y, final int width, final int height, final IconCoordinate coordinate) {
         drawGuiIconDouble(x, y, width, height, coordinate);
     }
-    public void drawGuiIconDouble(double x, double y, double width, double height, IconCoordinate coordinate) {
+    public void drawGuiIconDouble(final double x, final double y, final double width, final double height, final IconCoordinate coordinate) {
         coordinate.parentAtlas.bind();
-        Tessellator t = Tessellator.instance;
+        final Tessellator t = Tessellator.instance;
         if (coordinate.hasMeta("gui")) {
-            GuiTextureProperties properties = Objects.requireNonNull(coordinate.getMeta("gui", GuiTextureProperties.class));
+            final GuiTextureProperties properties = Objects.requireNonNull(coordinate.getMeta("gui", GuiTextureProperties.class));
             switch (properties.type) {
                 case GuiTextureProperties.TYPE_STRETCH: {
                     t.startDrawingQuads();
-                    t.addVertexWithUV(x,            y + height, zLevel, coordinate.getIconUMin(), coordinate.getIconVMax());
-                    t.addVertexWithUV(x + width,    y + height, zLevel, coordinate.getIconUMax(), coordinate.getIconVMax());
-                    t.addVertexWithUV(x + width,    y,          zLevel, coordinate.getIconUMax(), coordinate.getIconVMin());
-                    t.addVertexWithUV(x,            y,          zLevel, coordinate.getIconUMin(), coordinate.getIconVMin());
+                    t.addVertexWithUV(x,            y + height, this.zLevel, coordinate.getIconUMin(), coordinate.getIconVMax());
+                    t.addVertexWithUV(x + width,    y + height, this.zLevel, coordinate.getIconUMax(), coordinate.getIconVMax());
+                    t.addVertexWithUV(x + width,    y, this.zLevel, coordinate.getIconUMax(), coordinate.getIconVMin());
+                    t.addVertexWithUV(x,            y, this.zLevel, coordinate.getIconUMin(), coordinate.getIconVMin());
                     t.draw();
                     break;
                 }
                 case GuiTextureProperties.TYPE_TILE: {
-                    int repeatsY = MathHelper.floor(height / properties.height);
-                    double remainderY = height % properties.height;
+                    final int repeatsY = MathHelper.floor(height / properties.height);
+                    final double remainderY = height % properties.height;
 
-                    int repeatsX = MathHelper.floor(width / properties.width);
-                    double remainderX = width % properties.width;
+                    final int repeatsX = MathHelper.floor(width / properties.width);
+                    final double remainderX = width % properties.width;
 
-                    double uScale = (double) coordinate.width / properties.width;
-                    double vScale = (double) coordinate.height / properties.height;
+                    final double uScale = (double) coordinate.width / properties.width;
+                    final double vScale = (double) coordinate.height / properties.height;
 
                     for (int i = 0; i < repeatsX; i++) {
                         for (int j = 0; j < repeatsY; j++) {
@@ -610,23 +591,23 @@ public class Gui
                     break;
                 }
                 case GuiTextureProperties.TYPE_NINE_SLICE: {
-                    int innerWidth = properties.width - (properties.border.left + properties.border.right);
-                    int innerHeight = properties.height - (properties.border.top + properties.border.bottom);
-                    int innerLeft = properties.border.left;
-                    int innerTop = properties.border.top;
-                    int innerRight = properties.width - properties.border.right;
-                    int innerBottom = properties.height - properties.border.bottom;
+                    final int innerWidth = properties.width - (properties.border.left + properties.border.right);
+                    final int innerHeight = properties.height - (properties.border.top + properties.border.bottom);
+                    final int innerLeft = properties.border.left;
+                    final int innerTop = properties.border.top;
+                    final int innerRight = properties.width - properties.border.right;
+                    final int innerBottom = properties.height - properties.border.bottom;
 
-                    double uScale = (double) coordinate.width / properties.width;
-                    double vScale = (double) coordinate.height / properties.height;
+                    final double uScale = (double) coordinate.width / properties.width;
+                    final double vScale = (double) coordinate.height / properties.height;
 
-                    double leftHeight = height - (properties.border.top + properties.border.bottom);
-                    int repeatsY = MathHelper.floor(leftHeight / innerHeight);
-                    double remainderY = leftHeight % innerHeight;
+                    final double leftHeight = height - (properties.border.top + properties.border.bottom);
+                    final int repeatsY = MathHelper.floor(leftHeight / innerHeight);
+                    final double remainderY = leftHeight % innerHeight;
 
-                    double topWidth = width - (properties.border.left + properties.border.right);
-                    int repeatsX = MathHelper.floor(topWidth / innerWidth);
-                    double remainderX = topWidth % innerWidth;
+                    final double topWidth = width - (properties.border.left + properties.border.right);
+                    final int repeatsX = MathHelper.floor(topWidth / innerWidth);
+                    final double remainderX = topWidth % innerWidth;
 
 
                     { // Inner
